/* A YACC parser generated from "parser.y" */

# line 14
#ifndef lint
#define lint
#endif
#define defTycon(n,l,lhs,rhs,w)  tyconDefn(intOf(l),lhs,rhs,w); sp-=n
#define sigdecl(l,vs,t)          ap(SIGDECL,triple(l,vs,t))
#define grded(gs)                ap(GUARDED,gs)
#define bang(t)                  ap(BANG,t)
#define only(t)                  ap(ONLY,t)
#define letrec(bs,e)             (nonNull(bs) ? ap(LETREC,pair(bs,e)) : e)
#define yyerror(s)               /* errors handled elsewhere */
#define YYSTYPE                  Cell

static Cell   local gcShadow     Args((Int,Cell));
static Void   local syntaxError  Args((String));
static String local unexpected   Args((Void));
static Cell   local checkPrec    Args((Cell));
static Void   local fixDefn      Args((Syntax,Cell,Cell,List));
static Void   local setSyntax    Args((Int,Syntax,Cell));
static Cell   local buildTuple   Args((List));
static List   local checkContext Args((List));
static Cell   local checkPred    Args((Cell));
static Pair   local checkDo      Args((List));
static Cell   local checkTyLhs   Args((Cell));
static Cell   local tidyInfix    Args((Cell));

/* For the purposes of reasonably portable garbage collection, it is
 * necessary to simulate the YACC stack on the Hugs stack to keep
 * track of all intermediate constructs.  The lexical analyser
 * pushes a token onto the stack for each token that is found, with
 * these elements being removed as reduce actions are performed,
 * taking account of look-ahead tokens as described by gcShadow()
 * below.
 *
 * Of the non-terminals used below, only start, topDecl, fixDecl & begin
 * do not leave any values on the Hugs stack.  The same is true for the
 * terminals EXPR and SCRIPT.  At the end of a successful parse, there
 * should only be one element left on the stack, containing the result
 * of the parse.
 */

#define gc0(e)                   gcShadow(0,e)
#define gc1(e)                   gcShadow(1,e)
#define gc2(e)                   gcShadow(2,e)
#define gc3(e)                   gcShadow(3,e)
#define gc4(e)                   gcShadow(4,e)
#define gc5(e)                   gcShadow(5,e)
#define gc6(e)                   gcShadow(6,e)
#define gc7(e)                   gcShadow(7,e)

#define EXPR 257
#define SCRIPT 258
#define CASEXP 259
#define OF 260
#define DATA 261
#define TYPE 262
#define IF 263
#define THEN 264
#define ELSE 265
#define WHERE 266
#define LET 267
#define IN 268
#define INFIX 269
#define INFIXL 270
#define INFIXR 271
#define PRIMITIVE 272
#define TNEWTYPE 273
#define DEFAULT 274
#define DERIVING 275
#define DO 276
#define TCLASS 277
#define TINSTANCE 278
#define REPEAT 279
#define ALL 280
#define VAROP 281
#define VARID 282
#define NUMLIT 283
#define CHARLIT 284
#define STRINGLIT 285
#define CONOP 286
#define CONID 287
#define RECSELID 288
#define COCO 289
#define UPTO 290
#define FROM 291
#define ARROW 292
#define IMPLIES 293
#define MODULE 294
#define IMPORT 295
#define HIDING 296
#define QUALIFIED 297
#define ASMOD 298
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern short yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

#line 629


static Cell local gcShadow(n,e)         /* keep parsed fragments on stack  */
Int  n;
Cell e; {
    /* If a look ahead token is held then the required stack transformation
     * is:
     *   pushed: n               1     0          1     0
     *           x1  |  ...  |  xn  |  la   ===>  e  |  la
     *                                top()            top()
     *
     * Othwerwise, the transformation is:
     *   pushed: n-1             0        0
     *           x1  |  ...  |  xn  ===>  e
     *                         top()     top()
     */
    if (yychar>=0) {
	pushed(n-1) = top();
	pushed(n)   = e;
    }
    else
	pushed(n-1) = e;
    sp -= (n-1);
    return e;
}

static Void local syntaxError(s)       /* report on syntax error           */
String s; {
    ERRMSG(row) "Syntax error in %s (unexpected %s)", s, unexpected()
    EEND;
}

static String local unexpected() {      /* find name for unexpected token  */
    static char buffer[100];
    static char *fmt = "%s \"%s\"";
    static char *kwd = "keyword";

    switch (yychar) {
	case 0         : return "end of input";

#define keyword(kw) sprintf(buffer,fmt,kwd,kw); return buffer;
	case INFIXL    : keyword("infixl");
	case INFIXR    : keyword("infixr");
	case INFIX     : keyword("infix");
	case TINSTANCE : keyword("instance");
	case TCLASS    : keyword("class");
	case PRIMITIVE : keyword("primitive");
	case CASEXP    : keyword("case");
	case OF        : keyword("of");
	case IF        : keyword("if");
	case THEN      : keyword("then");
	case ELSE      : keyword("else");
	case WHERE     : keyword("where");
	case TYPE      : keyword("type");
	case DATA      : keyword("data");
	case TNEWTYPE  : keyword("newtype");
	case LET       : keyword("let");
	case IN        : keyword("in");
	case DERIVING  : keyword("deriving");
	case DEFAULT   : keyword("default");
	case IMPORT    : keyword("import");
	case MODULE    : keyword("module");
	case ALL       : keyword("forall");
#undef keyword

	case ARROW     : return "`->'";
	case '='       : return "`='";
	case COCO      : return "`::'";
	case '-'       : return "`-'";
	case '!'       : return "`!'";
	case ','       : return "comma";
	case '@'       : return "`@'";
	case '('       : return "`('";
	case ')'       : return "`)'";
	case '|'       : return "`|'";
	case '.'       : return "`.'";
	case ';'       : return "`;'";
	case UPTO      : return "`..'";
	case '['       : return "`['";
	case ']'       : return "`]'";
	case '_'       : return "`_'";
	case FROM      : return "`<-'";
	case '\\'      : return "backslash (lambda)";
	case '~'       : return "tilde";
	case '`'       : return "backquote";
#if TREX
	case RECSELID  : sprintf(buffer,"selector \"#%s\"",
				 textToStr(extText(snd(yylval))));
			 return buffer;
#endif
	case VAROP     :
	case VARID     :
	case CONOP     :
	case CONID     : sprintf(buffer,"symbol \"%s\"",
				 textToStr(textOf(yylval)));
			 return buffer;
	case HIDING    : return "symbol \"hiding\"";
	case QUALIFIED : return "symbol \"qualified\"";
	case ASMOD     : return "symbol \"as\"";
	case NUMLIT    : return "numeric literal";
	case CHARLIT   : return "character literal";
	case STRINGLIT : return "string literal";
	case IMPLIES   : return "`=>'";
	default        : return "token";
    }
}

static Cell local checkPrec(p)         /* Check for valid precedence value */
Cell p; {
    if (!isInt(p) || intOf(p)<MIN_PREC || intOf(p)>MAX_PREC) {
	ERRMSG(row) "Precedence value must be an integer in the range [%d..%d]",
		    MIN_PREC, MAX_PREC
	EEND;
    }
    return p;
}

static Void local fixDefn(a,line,p,ops)/* Declare syntax of operators      */
Syntax a;
Cell   line;
Cell   p;
List   ops; {
    Int l = intOf(line);
    a     = mkSyntax(a,intOf(p));
    map2Proc(setSyntax,l,a,ops);
}

static Void local setSyntax(line,sy,op)/* set syntax of individ. operator  */
Int    line;
Syntax sy;
Cell   op; {
    addSyntax(line,textOf(op),sy);
    opDefns = cons(op,opDefns);
}

static Cell local buildTuple(tup)      /* build tuple (x1,...,xn) from list*/
List tup; {                            /* [xn,...,x1]                      */
    Int  n = 0;
    Cell t = tup;
    Cell x;

    do {                               /*     .                    .       */
	x      = fst(t);               /*    / \                  / \      */
	fst(t) = snd(t);               /*   xn  .                .   xn    */
	snd(t) = x;                    /*        .    ===>      .          */
	x      = t;                    /*         .            .           */
	t      = fun(x);               /*          .          .            */
	n++;                           /*         / \        / \           */
    } while (nonNull(t));              /*        x1  NIL   (n)  x1         */
    fst(x) = mkTuple(n);
    return tup;
}

static List local checkContext(con)     /* validate context		   */
Type con; {
    mapOver(checkPred,con);
    return con;
}

static Cell local checkPred(c)		/* Check that type expr is a valid */
Cell c; {                               /* constraint			   */
    Cell cn = getHead(c);
#if TREX
    if (isExt(cn) && argCount==1)
	return c;
#endif
    if (!isCon(cn) || argCount==0)
	syntaxError("class expression");
    return c;
}

static Pair local checkDo(dqs)          /* convert reversed list of dquals */
List dqs; {                             /* to an (expr,quals) pair         */
    if (isNull(dqs) || whatIs(hd(dqs))!=DOQUAL) {
	ERRMSG(row) "Last generator in do {...} must be an expression"
	EEND;
    }
    fst(dqs) = snd(fst(dqs));           /* put expression in fst of pair   */
    snd(dqs) = rev(snd(dqs));           /* & reversed list of quals in snd */
    return dqs;
}

static Cell local checkTyLhs(c)         /* check that lhs is of the form   */
Cell c; {                               /* T a1 ... a                      */
    Cell tlhs = c;
    while (isAp(tlhs) && whatIs(arg(tlhs))==VARIDCELL)
	tlhs = fun(tlhs);
    if (whatIs(tlhs)!=CONIDCELL) {
	ERRMSG(row) "Illegal left hand side in type definition"
	EEND;
    }
    return c;
}

/* Expressions involving infix operators or unary minus are parsed as elements
 * of the following type:
 *
 *     data OpExp = Only Exp | Neg OpExp | Infix OpExp Op Exp
 *
 * (The algorithms here do not assume that negation can be applied only once,
 * i.e., that - - x is a syntax error, as required by the Haskell report.
 * Instead, that restriction is captured by the grammar itself, given above.)
 *
 * There are rules of precedence and grouping, expressed by two functions:
 *
 *     prec :: Op -> Int;   assoc :: Op -> Assoc    (Assoc = {L, N, R})
 *
 * OpExp values are rearranged accordingly when a complete expression has
 * been read using a simple shift-reduce parser whose result may be taken
 * to be a value of the following type:
 *
 *     data Exp = Atom Int | Negate Exp | Apply Op Exp Exp | Error String
 *
 * The machine on which this parser is based can be defined as follows:
 *
 *     tidy                         :: OpExp -> [(Op,Exp)] -> Exp
 *     tidy (Only a)      []         = a
 *     tidy (Only a)      ((o,b):ss) = tidy (Only (Apply o a b)) ss
 *     tidy (Infix a o b) []         = tidy a [(o,b)]
 *     tidy (Infix a o b) ((p,c):ss)
 *                      | shift  o p = tidy a ((o,b):(p,c):ss)
 *                      | red    o p = tidy (Infix a o (Apply p b c)) ss
 *                      | ambig  o p = Error "ambiguous use of operators"
 *     tidy (Neg e)       []         = tidy (tidyNeg e) []
 *     tidy (Neg e)       ((o,b):ss)
 *                      | nshift o   = tidy (Neg (underNeg o b e)) ss
 *                      | nred   o   = tidy (tidyNeg e) ((o,b):ss)
 *                      | nambig o   = Error "illegal use of negation"
 *
 * At each stage, the parser can either shift, reduce, accept, or error.
 * The transitions when dealing with juxtaposed operators o and p are
 * determined by the following rules:
 *
 *     shift o p  = (prec o > prec p)
 *               || (prec o == prec p && assoc o == L && assoc p == L)
 *
 *     red o p    = (prec o < prec p)
 *               || (prec o == prec p && assoc o == R && assoc p == R)
 *
 *     ambig o p  = (prec o == prec p)
 *               && (assoc o == N || assoc p == N || assoc o /= assoc p)
 *
 * The transitions when dealing with juxtaposed unary minus and infix operators
 * are as follows.  The precedence of unary minus (infixl 6) is hardwired in
 * to these definitions, as it is to the definitions of the Haskell grammar
 * in the official report.
 *
 *     nshift o   = (prec o > 6)
 *     nred   o   = (prec o < 6) || (prec o == 6 && assoc o == L)
 *     nambig o   = prec o == 6 && (assoc o == R || assoc o == N)
 *
 * An OpExp of the form (Neg e) means negate the last thing in the OpExp e;
 * we can force this negation using:
 *
 *     tidyNeg              :: OpExp -> OpExp
 *     tidyNeg (Only e)      = Only (Negate e)
 *     tidyNeg (Infix a o b) = Infix a o (Negate b)
 *     tidyNeg (Neg e)       = tidyNeg (tidyNeg e)
 * 
 * On the other hand, if we want to sneak application of an infix operator
 * under a negation, then we use:
 *
 *     underNeg                  :: Op -> Exp -> OpExp -> OpExp
 *     underNeg o b (Only e)      = Only (Apply o e b)
 *     underNeg o b (Neg e)       = Neg (underNeg o b e)
 *     underNeg o b (Infix e p f) = Infix e p (Apply o f b)
 *
 * As a concession to efficiency, we lower the number of calls to syntaxOf
 * by keeping track of the values of sye, sys throughout the process.  The
 * value APPLIC is used to indicate that the syntax value is unknown.
 */

static Cell local tidyInfix(e)		/* convert OpExp to Expr	   */
Cell e; {				/* :: OpExp			   */
    Cell s     = NIL;			/* :: [(Op,Exp)]		   */
    Syntax sye = APPLIC;		/* Syntax of op in e (init unknown)*/
    Syntax sys = APPLIC;		/* Syntax of op in s (init unknown)*/

    for (;;) {
	switch (whatIs(e)) {
	    case ONLY : e = snd(e);
                        while (nonNull(s)) {
                            Cell next   = arg(fun(s));
                            arg(fun(s)) = e;
                            e           = s;
                            s           = next;
			}
		        return e;

	    case NEG  : if (nonNull(s)) {

			    if (sys==APPLIC) {	/* calculate sys	   */
				sys = syntaxOf(textOf(fun(fun(s))));
				if (sys==APPLIC) sys=DEF_OPSYNTAX;
			    }

			    if (precOf(sys)==UMINUS_PREC &&	/* nambig  */
				assocOf(sys)!=UMINUS_ASSOC) {
				ERRMSG(row)
				 "Ambiguous use of unary minus with \"%s\"",
				 textToStr(textOf(fun(fun(s))))
				EEND;
			    }

			    if (precOf(sys)>UMINUS_PREC) {	/* nshift  */
				Cell e1    = snd(e);
				Cell t     = s;
                                s          = arg(fun(s));
				while (whatIs(e1)==NEG)
				    e1 = snd(e1);
				arg(fun(t)) = arg(e1);
                                arg(e1)     = t;
				sys         = APPLIC;
				continue;
			    }
			
			}

			/* Intentional fall-thru for nreduce and isNull(s) */

			{   Cell prev = e;		/* e := tidyNeg e  */
			    Cell temp = arg(prev);
			    Int  nneg = 1;
			    for (; whatIs(temp)==NEG; nneg++) {
				fun(prev) = nameNegate;
				prev	  = temp;
				temp	  = arg(prev);
			    }
			    if (isInt(arg(temp))) {	/* special cases   */
				if (nneg&1)		/* for literals    */
				    arg(temp) = mkInt(-intOf(arg(temp)));
			    }
#if BIGNUMS
			    else if (isBignum(arg(temp))) {
				if (nneg&1)
				    arg(temp) = bigNeg(arg(temp));
			    }
#endif
			    else if (isFloat(arg(temp))) {
				if (nneg&1)
				    arg(temp) = mkFloat(-floatOf(arg(temp)));
			    }
			    else {
				fun(prev) = nameNegate;
				arg(prev) = arg(temp);
				arg(temp) = e;
			    }
			    e = temp;
			}
			continue;

	    default   : if (isNull(s)) {/* Move operation onto empty stack */
			    Cell next   = arg(fun(e));
			    s           = e;
			    arg(fun(s)) = NIL;
                            e           = next;
			    sys         = sye;
			    sye         = APPLIC;
			}
                        else {		/* deal with pair of operators	   */

			    if (sye==APPLIC) {	/* calculate sys and sye   */
				sye = syntaxOf(textOf(fun(fun(e))));
				if (sye==APPLIC) sye=DEF_OPSYNTAX;
			    }
			    if (sys==APPLIC) {
				sys = syntaxOf(textOf(fun(fun(s))));
				if (sys==APPLIC) sys=DEF_OPSYNTAX;
			    }

			    if (precOf(sye)==precOf(sys) &&	/* ambig   */
				(assocOf(sye)!=assocOf(sys) ||
				 assocOf(sye)==NON_ASS)) {
				ERRMSG(row)
				"Ambiguous use of operator \"%s\" with \"%s\"",
			    	 textToStr(textOf(fun(fun(e)))),
			    	 textToStr(textOf(fun(fun(s))))
				EEND;
			    }

			    if (precOf(sye)>precOf(sys) ||	/* shift   */
				(precOf(sye)==precOf(sys) &&
				 assocOf(sye)==LEFT_ASS &&
				 assocOf(sys)==LEFT_ASS)) {
				Cell next   = arg(fun(e));
				arg(fun(e)) = s;
				s           = e;
				e	    = next;
				sys         = sye;
				sye         = APPLIC;
			    }
			    else {				/* reduce */
				Cell next   = arg(fun(s));
				arg(fun(s)) = arg(e);
				arg(e)      = s;
				s	    = next;
				sys         = APPLIC;
				/* sye unchanged */
			    }
			}
			continue;
	}
    }
}

/*-------------------------------------------------------------------------*/
short yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 111,
	289, 228,
	44, 228,
	-2, 262,
-1, 123,
	293, 160,
	-2, 172,
-1, 200,
	293, 160,
	-2, 83,
-1, 212,
	293, 160,
	-2, 139,
-1, 215,
	293, 160,
	-2, 141,
-1, 229,
	293, 159,
	-2, 186,
-1, 240,
	289, 231,
	-2, 185,
-1, 331,
	293, 160,
	-2, 178,
-1, 348,
	293, 161,
	-2, 189,
-1, 350,
	293, 162,
	-2, 191,
-1, 367,
	289, 231,
	-2, 185,
-1, 408,
	123, 239,
	-2, 182,
	};
#define YYNPROD 330
# define YYLAST 2106
short yyact[]={

  32, 520, 426, 119, 291, 109, 551,   5, 463, 415,
 183, 327, 328, 398, 342, 399, 535, 343,  88,  61,
  62, 541, 207, 391, 113, 366,  22, 376,  75, 101,
 304, 301,  94, 290,  86, 121, 475,  42, 486, 464,
 425,  46,  55, 306, 323,  23, 127,  43,  89, 239,
 306,  33,  40, 197, 135,  48, 126,  33, 120, 321,
 316,  33, 136, 311, 228,  34,  35,  36, 196, 562,
 523,  34,  35,  36, 518,  34,  35,  36,  90,  80,
 431, 385, 128,  59, 267, 218, 482, 383, 564, 131,
  42, 158, 363, 132, 116,  45,  29, 117, 586, 115,
  21, 318, 567, 136, 203, 203, 218, 203, 203, 195,
 173, 114, 180, 126, 199, 495, 201, 205, 254, 211,
 214, 329, 319, 240, 247, 191, 194, 312, 118, 247,
 116,  20, 247, 117, 417, 115, 477, 116, 334, 539,
 117, 275, 115,  51, 259, 198, 260, 476, 231, 474,
 141, 263, 156, 261, 276,  49,  52,  44, 269, 265,
   6, 340, 373, 146, 123, 147,  95, 252, 150, 277,
 270, 462, 278, 184, 279, 571, 280,   4,   2,   3,
 332, 286, 464, 287,  97, 288, 494, 293, 187,  96,
 360, 225, 181, 362, 434,  60,  65, 275, 309, 222,
 285, 247, 264, 203,  68, 247,  53, 461, 170, 273,
 276, 172,  63, 247,  82, 224, 247, 247, 127, 295,
 307, 257, 200, 204, 151, 212, 215, 337, 314, 247,
 339, 247, 256, 249, 244, 294, 268, 371, 179,  66,
 433, 230, 178, 367, 247, 145, 154, 272, 468, 367,
 369, 247, 326, 458, 129, 247, 570, 266, 320, 262,
 189, 322, 225,  65, 347, 188, 186, 557, 336, 556,
 582, 563, 379, 361,  19, 561,  54, 381, 427, 368,
  33, 300,  65, 472,  27, 126, 370,  33,  24,  25,
  26, 171,  31,  28,  34,  35,  36, 139, 477, 305,
 333,  34,  35,  36, 185, 424, 305, 208, 395, 247,
 389, 247,  33, 111, 247, 160, 454,  31, 127, 455,
 516, 313, 435, 384, 394, 436,  34,  35,  36, 419,
 572, 240, 247,  33, 247, 111, 331, 406, 396, 124,
 157, 420, 416, 157, 397, 387, 317,  34,  35,  36,
 127, 217, 127, 271, 203, 297, 231, 247, 182, 275,
 247, 365, 247, 251, 247, 410, 247, 365,  33, 437,
 418, 273, 276, 126, 299, 388, 386, 296, 456, 298,
 209,  31,  34,  35,  36, 457, 538, 281, 465, 274,
 467,  50, 447, 401, 221, 448,  54, 449, 130, 451,
 333, 247, 247, 247, 169, 247, 247, 125, 394, 400,
 367, 309, 450, 203, 470, 203, 409, 247, 466, 309,
 473, 469, 247, 247, 380, 247, 247, 151, 508, 402,
 367, 247, 247, 247,   8, 378, 331, 581, 512, 338,
 421, 247, 422, 560, 247, 274, 247, 372, 158, 230,
 502, 515, 499, 513, 247, 559, 247, 481, 483, 487,
 503, 111, 238, 165, 111, 522, 528, 131, 440, 527,
 443, 132, 445, 110, 302, 303, 413, 247, 523, 414,
 247, 247, 247, 479, 247, 247, 525, 367, 247, 247,
 532, 403, 537, 335, 247, 110,  30, 247, 247, 247,
 552, 295, 345, 406, 533, 545, 247, 526, 333, 547,
 554, 428, 555, 333, 333, 333, 190, 530, 358, 480,
  84, 359, 245, 406, 558, 158, 514, 245, 365, 416,
 234, 497, 357, 498, 540, 176, 158, 111, 531, 478,
 524, 247, 238, 247, 505, 506, 157, 504, 365, 505,
 505, 505, 509, 510, 511, 158, 438, 127, 576, 401,
 575, 471, 568, 577, 479, 127, 479, 578, 251, 120,
 479, 111, 440, 247, 443, 584, 580, 552, 583, 401,
 579, 345, 423, 485, 382, 490, 491, 496, 522, 164,
 428, 573, 574, 209, 163, 402, 162, 501, 202, 245,
 480, 355, 480, 245, 356, 365, 480, 274, 585, 161,
 428, 245, 495, 308, 245, 402, 192, 193, 354, 241,
 543, 110, 543, 479, 110, 479, 543, 352, 350, 245,
 353, 351, 407, 289, 177, 168, 251, 176, 169, 489,
 492, 155, 166, 390, 158, 167, 227, 333, 392, 216,
 234, 500,  41, 245,  76, 149, 234, 403,  33, 480,
 460, 480, 544, 408, 544, 345, 459, 428, 544, 282,
 238,  33,  34,  35,  36, 123, 235, 403, 375, 543,
  85, 569,  77, 331,  87,  34,  35,  36,  17, 439,
  33, 442, 112, 446,  47, 346, 148, 110, 374, 377,
  81,  57, 344,   9,  34,  35,  36, 223, 220, 111,
  23, 345, 245, 521, 251,  11, 219, 144,  79, 546,
  33, 544, 142, 548, 237,  31, 236, 232, 549,  92,
 245, 110, 245, 507,  34,  35,  36, 325, 234, 241,
 324, 213, 210, 111, 206, 241, 566, 345, 283, 536,
 565, 550, 439, 428, 442,  23, 405, 441, 404, 444,
  11,  29,  12, 534, 245,  21,  93,  33, 519, 553,
 484, 517, 346, 393,  92, 341,  91, 486,  33, 344,
 226,  34,  35,  36,  39,  38,  37,   1,   0,   0,
   0,   0,  34,  35,  36,   0,  20,  33,   0,   0,
 245, 245, 346, 245, 245,   0,  29,  12,  33,   0,
  21,  34,  35,  36,   0, 245,   0, 234,  71,   0,
 245, 245,  34,  35,  36,  23,  74, 241, 131,  83,
  69,  72, 132, 482,  33,   0, 521, 234, 536, 245,
  33,  20, 245,   0, 245, 126, 553,   0,  34,  35,
  36,   0,   0,   0,  34,  35,  36,   0,   0, 241,
   0, 441,   0, 444,   0,  23, 542,   0,   0, 110,
  11,   0,   0, 486,   0,   0,  29,  12, 245, 245,
  21,  53,   0, 245,   0,   0,  33, 245,   0,   0,
   0, 346, 245, 377, 234,   0, 245, 245,   0, 529,
  34,  35,  36, 110, 245,   0, 241,   0,   0,  23,
   0,  20,   0,   0,  11,   0,  29,  12,   0,   0,
  21,   0,   0,   0, 131,   0, 241,   0, 132,  15,
   0, 103, 102,  14,   0,   0,   0,  13,   0, 100,
  98,  99, 105, 104, 108,   0,  16, 106, 107,  27,
   0,  20,  33,  24,  25,  26,   0,  31,  28,   0,
  29,  12,   0, 248,  21, 101,  34,  35,  36,   0,
  23,   0,   0,   0,  15,  11, 103, 102,  14,   0,
   0,   0,  13, 241, 100,  98,  99, 105, 104, 108,
  33,  16, 106, 107,  27,  20,   0,  33,  24,  25,
  26,   0,  31,  28,  34,  35,  36,   0,   0,   0,
   0,  34,  35,  36, 131,   0, 253,   0, 132,  33,
   0,  29,  12,  54, 246,  21,   0,   0,   0,   0,
   0,   0,   0,  34,  35,  36,   0,   0,  23, 284,
   0,   7,   0, 138,  15,   0,   0,   0,  14,   0,
   0,   0,  13,   0,   0,   0,  20,   0,   0,   0,
   0,  16,   0,   0,  27,   0,  70,  33,  24,  25,
  26,  73,  31,  28,   0,   0,   0,   0,   0,   0,
   0,  34,  35,  36,  15,   0, 103, 102,  14,  29,
  12,   0,  13,  21,   0,  23,   0, 105, 104, 108,
  11,  16, 106, 107,  27,   0,   0,  33,  24,  25,
  26,   0,  31,  28, 143,  33,   0,   0,   0,   0,
 126,  34,  35,  36,  20,   7,   0,   0,  15,  34,
  35,  36,  14,   0,   0,   0,  13,   0,   0,  23,
   0,   0,   0,   0,  11,  16,  29,  12,  27,   0,
  21,  33,  24,  25,  26,   0,  31,  28,   0,   0,
   0,   0,   0,   0,   0,  34,  35,  36,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0, 129,
  23,  20,   0,  18,   0,  11,   7,   0,   0,  15,
  29,  12,   0,  14,  21,   0,  58, 292,   0,   0,
   0,  64,   0,   0,  67,  33,  16,  23, 161,  27,
 126,   0,  33,  24,  25,  26,   0,  31,  28,  34,
  35,  36,   0,   0,   0,  20,  34,  35,  36,   0,
   0,  29,  12,   0,   0,  21,   0,   0,   0,   0,
   0, 140,   0,   0,   0,   0,   0,  23,   0,   0,
 159,   0, 138,   0,   0,   0,   0,  15,  29,  12,
 248,  14,  21, 174, 175,  13,  20,   0,   0,   0,
   0,   0,   0,   0,  16,   0,   0,  27,   0,   0,
  33,  24,  25,  26,   0,  31,  28,   0,   0,   0,
   0,   0,   0,  20,  34,  35,  36,   0,  29,  12,
   0,   0,  21,   0,  23,   0,   0,   0,   0, 133,
   0, 131,   0,   0,  15, 132, 482,   0,  14,   0,
   0,   0,  13,   0,   0,   0,   0,   0,   0,   0,
   0,  16,   0,  20,  27,   0,   0,  33,  24,  25,
  26,   0,  31,  28,   0,   0,   0,   0,   0,  23,
   0,  34,  35,  36,   0,  29,  12,   0,  15,  21,
   0,   0,  14,   0,   0,   0,  13,   0,   0,   0,
   0,   0,   0,   0,   0,  16,   0,   0,  27,   0,
   0,  33,  24,  25,  26,   0,  31,  28,   0,   0,
  20,   0,   0,   0,   0,  34,  35,  36, 275,  15,
  29,  12,   0, 153,  21, 429, 364, 152,   0,  83,
   0, 276,   0,   0,   0,   0,  16,   0,   0,  27,
   0,   0,  33,  24,  25,  26,  15,  31,  28, 248,
  14,   0,   0,   0,  13,  20,  34,  35,  36,   0,
   0,   0,   0,  16,   0,   0,  27,   0,   0,  33,
  24,  25,  26,   0,  31,  28, 131, 429, 364,   0,
 132,  83,   0,  34,  35,  36,  15,   0, 275,   0,
  14,   0,   0,   0,  13, 242, 364,   0, 122,  83,
 131, 276,   0,  16, 132,   0,  27,   0,   0,  33,
  24,  25,  26,   0,  31,  28,   0,   0,   0,   0,
   0,   0,  33,  34,  35,  36,  54, 246, 131,   0,
   0,   0, 132,   0,  23,   0,  34,  35,  36,   0,
   0,   0,   0,  15,   0,   0, 131,  14,   0, 131,
 132,  13,   0, 132,   0, 429, 364,   0,   0,  83,
  16,   0,   0,  27,   0,   0,  33,  24,  25,  26,
   0,  31,  28,   0,   0,   0,   0,   0,   0,   0,
  34,  35,  36, 429, 229,  29,   0,  83,  15,  21,
   0,   0,  14,   0,   0,   0,  13,   0,   0,   0,
 242, 364,   0,   0,  83,  16, 131,   0,  27,   0,
 132,  33,  24,  25,  26,   0,  31,  28, 242, 229,
  20,   0,  83,   0,   0,  34,  35,  36,   0,   0,
   0,   0,   0,   0, 131, 248, 452,   0, 132, 453,
   0, 129,   0, 248, 348,   0,   0, 349,   0,   0,
   0, 131,   0,   0,   0, 132,   0,   0,   0,   0,
   0,   0,   0,   0,   0, 427, 274,  33,   0, 131,
 248, 411, 126, 132, 412,   0,   0, 233,   0,   0,
   0,  34,  35,  36,   0,   0, 131,   0, 248,   0,
 132,  33,   0, 129, 131, 248, 246,   0, 132,   0,
   0, 430,   0,   0,   0,  34,  35,  36, 493,   0,
   0, 129, 248,   0, 129, 486,   0, 427,   0,  33,
   0, 131,   0, 495, 126, 132,   0,   0,   0, 233,
   0, 488, 248,  34,  35,  36, 274,  33, 486, 131,
  33,   0, 126, 132,   0, 126, 131, 233,   0,   0,
 132,  34,  35,  36,  34,  35,  36,   0,   0, 248,
   0,   0,   0, 131,   0,   0, 131, 132,   0,   0,
 132, 129,   0,  27,   0,   0,  33,  24,  25,  26,
 315,  31,  28, 131,   0,   0,   0, 132,   0, 131,
  34,  35,  36, 132, 248, 427,   0,  33,   0, 129,
 330,   0, 126,   0,   0,   0,   0, 233,   0,   0,
 131,  34,  35,  36, 132, 310, 129, 248,   0,   0,
   0,   0,   0, 427,   0,  33,   0,   0,   0, 248,
 126,   0,   0,   0, 129, 233,   0,   0,   0,  34,
  35,  36,  33,   0,   0, 131,   0, 126,   0, 132,
   0, 131, 233,   0, 486, 132,  34,  35,  36,  10,
  33,   0,   0,   0,   0, 126,   0, 486, 131,   0,
 233,  56, 132,   0,  34,  35,  36,  33,   0,   0,
 131,   0, 246,  78, 132,  33,   0, 243,   0,   0,
 246,  34,  35,  36,   0, 243,   0,   0,   0,  34,
  35,  36,   0,   0, 129, 131, 134,   0,   0, 132,
   0,   0,  33,   0,   0, 137,   0, 246, 131,   0,
   0,   0, 132,   0,   0,   0,  34,  35,  36,  56,
  33,   0,   0,   0,   0, 126,   0,  33,   0,   0,
   0,   0, 246,   0,  34,  35,  36, 243,   0,   0,
   0,  34,  35,  36,  33,   0,   0,  33,   0, 246,
   0,   0, 246,   0, 432,   0,   0,   0,  34,  35,
  36,  34,  35,  36,  33,   0,   0,   0,   0, 246,
  33,   0,   0,   0, 250, 246,   0,   0,  34,  35,
  36,   0,   0, 255,  34,  35,  36,   0, 258,   0,
   0,  33,   0,   0,   0,   0, 246,   0,   0,   0,
   0,   0,   0,   0,   0,  34,  35,  36,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0, 137,   0,   0,  33,   0,   0,   0,
   0, 246,  33,   0,   0,   0,   0, 126,   0,   0,
  34,  35,  36,   0,   0,   0,  34,  35,  36,  33,
   0,   0,   0,   0, 126,   0,   0,   0,   0,   0,
   0,  33,   0,  34,  35,  36, 246,   0,   0,   0,
   0,   0,   0,   0,   0,  34,  35,  36,   0,   0,
   0,   0,   0,   0,   0,   0,  33,   0,   0,   0,
   0, 126,   0,   0,   0,   0,   0,   0,   0,  33,
  34,  35,  36,   0, 246,   0,   0,   0,   0,   0,
   0,   0,   0,  34,  35,  36 };
short yypact[]={

 -79,-1000, 869,-204,-1000,-109,-1000,-1000,-194, 110,
 110,1309,1474,  72, 869, 869,  89,1474,  73, 175,
1474,-1000,  81, 785,-1000,-1000,-1000,-1000,-1000, 869,
-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000, 670,-257,
-1000,-1000,-145,-1000,  72,1438,1264,-1000,-1000,-1000,
-1000,-1000,-1000,-225,-1000,1207,-1000,   5,  73,-118,
1055,-101, -95,1140,  73, 496,1474,  73, 496,1167,
 555, 553, 548, 422,-1000, 601, 594, 167, 110,1474,
1474, 593,-1000,-1000, 181, 145,  68, 360,  48,-1000,
 207, 206,-1000, 201,-1000,-1000,-1000,-1000,-158,-158,
-158,-188,-142, 558, 558,  51, 558, 558, 609,  62,
 138, 175,-1000, 606,-1000,-1000,-1000,-1000,-1000,-1000,
-229,-1000,1558,1635,-1000,-1000,-1000, 141,1672,-1000,
-1000, 923,-1000,1309,-1000, 136, 125,-1000,1309, 869,
  73, 869,  48,-1000, 200,-1000, 869,  79,  48, 198,
-1000,-207,  72, 869,  45, 309,-1000, 186, 164,  73,
  44,-1000,-1000,-1000,-1000,-1000,-1000, 869,-1000, 869,
-1000, 869, 708, 998, 159, 140,-1000,-1000, 869,-1000,
 869, 930, 869,-1000,-1000,-1000, 715,-1000,-266, 825,
 110,-1000, 110, 110,   3,-152,-1000, 552,-1000,-1000,
1734,-230,  86, 141,1699,-233,  57,-1000,-1000,-163,
-109,-234,1769,-109,-249,1769,1628,1740, 496,-1000,
-109,-1000, 869,  67,-1000, 869,-105, 408,1628,-1000,
1583, 587, 586, 577, 560, 491, 477, 149,-1000,-1000,
 141,-197,1435,1628,-1000,-1000,-1000,-1000,1540,-221,
1628,-1000, 144,-1000,1635,-1000,-1000,-1000,-1000,-1000,
-1000,-1000,1099,-103,1099,-1000,1140, 869,-118,-101,
-1000, 496, 869, 568, 555, 553, 548,-1000,-1000,-1000,
 543,-1000, 181, 108,-1000,-1000,-1000,-1000,-203, 279,
-1000,-210,  72,-1000,-1000,-1000, 715,-1000,-1000,-1000,
 266,-1000, 266, 266,-1000, 603, 604,  10,1628,-1000,
 376,-142,-1000,1610, 435,  94,-142,1740, 496,-1000,
-1000,-174,-1000,-174, 541, 261,-1000,-1000,-253,-1000,
1523,1389,-212,1652,-1000,-1000,-1000,-1000,-1000, 179,
  71, 281,-1000,-1000,-152,-1000, 516,-1000,-1000,1628,
-1000,1628,-1000,-231,-1000,-1000,1628,-1000,-1000,1628,
-1000,1628, 708,1628,-1000,1575, 275,-1000,-1000,-1000,
-1000,-1000,-1000, 869,  48, 194,-1000, -85,-1000,-1000,
-1000,-1000,-1000, 869, 930, 869,-118,-1000, 189, 110,
 604, 520,-1000, 239,-1000,-152,-1000,-119,  23,-1000,
1757,1220, 737, -10,1678,1655,  63,-1000,-1000,1417,
 526,-1000,-231,-1000,-231,-139,1807,-171, 389,-1000,
-1000,1769,1769,-1000,1628,1794, 504,-221,-1000,1365,
1794,1794,1794, 869, 670,-1000, 485,-1000,  30,-1000,
1635,-1000,-1000,1635,-1000,1769,-1000,-1000,-1000, 499,
-1000,-1000,-1000,1628,-1000,1628,-1000,-1000,1099,-109,
  58, 869,-1000,-1000,1099,-1000,-1000,-1000, 715,-1000,
 497,-1000, 515,   3, 496,-1000, 376,  99, -10,1769,
1769, 833,-184, 833,1769,-1000,1495, 833,1769,-1000,
-1000,-1000,-1000,1769, 496, 422, 376,1769,1769,-1000,
-1000,-1000,  94,-1000,-1000,1389,-1000, 223,-1000,-1000,
-1000,-1000,-1000,  48,-1000,-1000, 414, 402,-1000, 231,
-1000,-1000,-1000, 326,-1000,-1000,-1000,-1000,-1000,-223,
-1000,-1000,-1000,-1000, 227,-1000,-201,-1000,-1000,-185,
 833,-1000,1757,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
 131,-1000,  41,-1000,  23,-139,1438,-221,-1000,-1000,
-1000, 438, 869, 496,1740, 396, 226,-1000,-1000,-1000,
-1000, 496,  -2,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
-1000,-1000,-189,-1000,-1000,-1000,-1000 };
short yypgo[]={

   0, 787,   4,  47, 786, 785,  18,  10, 784, 652,
  24, 780,  48,  78, 776, 188, 775,  14,  17, 166,
  30,  23, 773, 274, 771, 768,   1,  26,  32, 516,
 281,  31, 694,  55,   0, 766, 189, 184,  53,  35,
 763, 118,  13,  36,  12,   9,  16,  11,  15, 138,
  21,  82, 180, 758, 756, 751, 234,   6,   5,   2,
 750, 746, 744,  22, 742, 741, 740, 737, 121, 733,
   3,  25, 339, 727, 407, 398, 676, 726, 724,  49,
 496,  83, 722, 717, 434, 716, 708, 707, 215, 160,
 703,1839, 701, 698, 696, 688,1183, 246, 654, 682,
 680, 214, 678,  27, 666, 660,   8, 655, 168, 641,
 152, 633,  33 };
short yyr1[]={

   0,   1,   1,   1,   4,   4,   8,   8,   9,   9,
  10,  10,  10,   6,   6,   6,   6,   6,  11,  11,
  11,  16,  16,  17,  17,  14,  14,  15,  19,  19,
  19,  19,  20,  20,  20,  21,  21,  21,  21,  22,
  22,  18,  18,  18,  18,  24,  24,  24,  24,  25,
  25,  26,  26,  13,  13,  28,  28,  28,  29,  29,
  30,  30,  31,  31,  31,  32,  32,  32,  32,  33,
  33,  12,  12,  12,  12,  35,  35,  35,  35,  36,
  36,  36,  36,  36,  36,  36,  36,  38,  38,  38,
  40,  40,  46,  46,  42,  42,  48,  48,  48,  48,
  48,  48,  48,  48,  48,  53,  53,  53,  54,  54,
  54,  54,  54,  50,  50,  50,  55,  55,  57,  57,
  45,  45,  43,  43,  43,  60,  60,  61,  61,  36,
  62,  62,  62,  63,  63,  36,  36,  36,  64,  64,
  65,  65,  66,  66,  67,  67,  47,  47,  68,  68,
  68,  68,  59,  59,  52,  69,  69,  70,  70,  44,
  44,  44,  44,  44,  44,  72,  73,  73,  73,  73,
  73,  39,  39,  74,  74,  74,  74,  49,  49,  51,
  51,  41,  41,  56,  56,  75,  75,  75,  75,  75,
  75,  75,  75,  75,  75,  75,  75,  75,  76,  76,
  71,  71,  77,  77,  77,  77,  78,  78,  79,  81,
  82,  82,  82,  82,  83,  83,  37,  37,  85,  85,
  86,  86,   3,   3,  87,  87,  88,  58,  58,  23,
  23,  80,  80,  80,  80,  34,  34,  34,  34,  27,
  27,   2,   2,  89,  89,  84,  84,  90,  90,  90,
  90,  90,  91,  91,  91,  91,  91,  91,  92,  92,
  95,  95,  96,  96,  96,  96,  96,  96,  96,  96,
  96,  96,  96,  96,  96,  96,  96,  96,  96,  96,
  96,  96,  96,  96,  98,  98,  99,  99, 101,  93,
  93, 102, 102, 103, 104, 104, 104, 105, 105, 106,
  94,  94, 107, 107, 108, 108, 108, 108,  97,  97,
 109, 109, 110, 110, 100, 100, 100, 100, 100, 100,
 100, 100, 111, 111, 112, 112, 112,   5,   7,   7 };
short yyr2[]={

   0,   3,   2,   1,   3,   1,   2,   1,   7,   2,
   1,   1,   1,   1,   3,   2,   4,   6,   0,   3,
   4,   3,   1,   1,   2,   3,   1,   0,   3,   6,
   4,   2,   0,   4,   3,   0,   1,   1,   2,   3,
   1,   1,   1,   4,   4,   0,   1,   1,   2,   3,
   1,   1,   1,   3,   1,   3,   3,   3,   1,   0,
   3,   1,   1,   1,   1,   1,   1,   1,   3,   1,
   3,   0,   1,   1,   2,   3,   3,   1,   1,   4,
   6,   5,   7,   2,   4,   5,   7,   2,   1,   1,
   3,   1,   3,   1,   3,   1,   4,   3,   3,   3,
   1,   1,   1,   4,   1,   3,   3,   2,   2,   2,
   2,   2,   3,   2,   1,   1,   3,   1,   3,   3,
   2,   2,   0,   2,   4,   0,   1,   3,   1,   4,
   3,   1,   1,   2,   1,   3,   3,   4,   3,   1,
   3,   1,   0,   1,   3,   1,   3,   1,   3,   3,
   3,   1,   4,   1,   3,   3,   1,   3,   1,   2,
   1,   3,   3,   1,   3,   3,   3,   3,   3,   3,
   1,   1,   1,   1,   3,   3,   1,   1,   1,   2,
   1,   2,   1,   1,   1,   1,   2,   3,   3,   3,
   3,   3,   3,   3,   5,   3,   2,   1,   2,   1,
   3,   3,   3,   3,   3,   3,   3,   1,   3,   3,
   0,   1,   1,   2,   3,   1,   3,   2,   2,   1,
   2,   1,   2,   0,   2,   1,   4,   3,   1,   1,
   3,   1,   3,   3,   3,   1,   1,   1,   1,   1,
   3,   1,   1,   3,   1,   1,   1,   4,   3,   2,
   3,   4,   4,   4,   6,   6,   4,   1,   2,   1,
   2,   1,   1,   3,   2,   1,   1,   4,   4,   2,
   1,   1,   1,   1,   3,   3,   3,   5,   1,   3,
   4,   4,   4,   3,   3,   3,   3,   1,   3,   1,
   2,   3,   1,   3,   1,   2,   1,   2,   1,   4,
   2,   1,   3,   1,   3,   2,   2,   1,   0,   1,
   3,   1,   1,   3,   0,   1,   1,   3,   3,   4,
   2,   5,   3,   1,   3,   1,   2,   1,   1,   1 };
short yychk[]={

-1000,  -1, 257, 258, 256,  -2, -89, 256, -84, -90,
 -91,  45,  92, 267, 263, 259, 276, -95, -96, -23,
 126,  95, -27,  40, 283, 284, 285, 279, 288,  91,
 -80, 287, -34, 282, 296, 297, 298,  -4,  -5,  -8,
 256,  -9, 294,  -3, 266, 289, -31, -32, -33,  45,
 281,  33,  46,  96, 286, -31, -91, -92, -96, -81,
 123,  -2,  -2, 123, -96, 123,  64, -96, 123,  45,
 281,  33,  46, 286,  41,  -2, -98, -99, -91, -32,
 -33, -76,-101,  44, -80,-100,  -2, -98,  -6, -12,
 -13, -14,  59, -35, -28, -19, -36, -37, 270, 271,
 269, 295, 262, 261, 273, 272, 277, 278, 274, -58,
 -84, -23,  -9, -10, 256, 287, 282, 285, -81, -70,
 -44, -39,  40, -41, -72, -74, 287, -34, -51, 256,
 -75,  91,  95,  45, -91, -34, 287, -91,  45, 292,
 -96, 268, -82,  59, -83, -37, 264, 260, -94,-107,
-108, -89, 267, 263, -97,-109,-110, -23,  40, -96,
 -97,  41,  41,  41,  41,  41,  41,  44,  41,  44,
  41, 124,  44, -31, -96, -96,  44,  41,  61,  93,
  44, 124, 290,  -7, 125, 256,  59, -15,  59,  59,
 -29, 283, -29, -29, -10, 297, 256, -38, 287, 256,
 -41, -44,  40, -34, -41, -44, -62, -63, 256, -23,
 -64, -44, -41, -65, -44, -41,  40, 289,  44, -85,
 -86, 256,  61, -87, -88, 124, -11,  40, 293,  41,
 -41, -71, -73, 292, -74, -76, -77, -78, -72, -79,
 -34, -80,  40, 292, -56, -75, 287, -34,  40,  92,
 292, -56, -39,  93, -41, -91,  96,  96, -91,  -2,
  -2,  -7,  59,  -2, 123,  -7,  59, 291, -81,  -2,
 125,  44,  61,  45, 281,  33,  46, 125,  -2,  -2,
  -2,-101, -80,  40,  41,  41,  41,  -2,  -2,-111,
-112,  -2, 267,  -2, -12, -28, -15, -19, -36, -37,
 -30, -31, -30, -30, -20, 296,  40, -10,  61, -34,
  61, 293,  41, -41, -71,  61, 293, 289,  44, 285,
  -3, 293,  -3, 293, -66, -67, -39, -47, -44, -68,
  40, -41, -52, -51, -49, -23,  -3,  -2, -88,  -2,
 266, -16, -17, -18, 294, -23, 287, -39,  41,  44,
  41,  44,  41,  44,  41,  41,  44,  41,  41,  44,
  41, 124,  44, 289,  41, -41, -71, -34, -39, -34,
 -39,  93, -37, 265, -93,-102,-103, -84,-108,  -2,
-110,  -2,  41, 290,  44, 291, -81, -12, -13,  44,
  40, -21,  44, -22, -18, 298, -20, -39, -42, -48,
  33, -51, -41, -52, -53, -54, -27, 256, 287,  40,
 -38,  41,  44,  41,  44, -45, -27,  40, -38, -47,
 -63, -41, -41,  41,  44, 293, -59, 280, -52,  40,
 292, 292, 292,  61, 123,  41,  44, -10,  40, -72,
 -41, -74, -72, -41, -74, -41, -72, -39, -39, -39,
 -79, -39,  41,  44,  41,  44,  -2,  -7,  59,-104,
-105, 292, 256,-106, 124,  -2,-112,  -2,  59, -31,
 -21,  41,  44, -10, 268, -43, 124, 275, -49, -51,
 -41, -33,  96, -33,  33, -52,  40, -33,  33, -56,
 -52, -52, -56,  33, 123, 286,  61, -41, -41, -43,
 -56, -52,  61, -39, -68, -41,  41, -69, -34, -68,
 -68, -68,  -2,  -6,  41, -17, 290, -24,  44, -25,
 -26, -23, -27,  40,  41,-103,  -3,-106,  -2, -84,
 -12,  41, -18, -20, -40, -46, -23, -48, 287,  40,
 -33, -50,  33, -49, -52, -50, -56, -50, -56, -56,
 -55, -57, -58, -23, -42, -45,  46,  44,  -7,  41,
  41,  44, 292,  44, 289, -60, -61, 287, -50, -49,
 125,  44, 289, -43, -43, -70, -34, -26,  -2, -46,
 -47,  41,  44, -57, -59, -39, 287 };
short yydef[]={

   0,  -2,   0,   0,   3, 223, 241, 242, 244, 245,
 246,   0,   0,   0,   0,   0,   0, 257, 261, 262,
   0, 265, 266,   0, 270, 271, 272, 273, 278, 314,
 229, 239, 231, 235, 236, 237, 238,   2,  71,   5,
 327,   7,   0,   1,   0,   0,   0,  62,  63,  64,
  65,  66,  67,   0,  69,   0, 249,   0, 259,   0,
 210,   0,   0,   0, 260, 308,   0, 264, 308,   0,
  65,  66,  67,  69, 269,   0,   0,   0, 246,   0,
   0,   0, 287, 199, 229,   0, 315, 316,   0,  13,
   0,  27,  72,  73,  54,  26,  77,  78,  59,  59,
  59,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,  -2,   6,  18,   9,  10,  11,  12, 222, 243,
   0, 158,   0,  -2, 163, 171, 182, 185, 173, 176,
 180,   0, 197,   0, 248,   0,   0, 250,   0,   0,
 258,   0,   0, 211, 212, 215,   0,   0,   0, 301,
 303, 307,   0,   0,   0, 309, 311, 312,   0, 263,
   0, 230, 232, 233, 234, 240, 274,   0, 275,   0,
 276,   0,   0,   0,   0,   0, 198, 283,   0, 279,
   0,   0, 320,   4, 328, 329,  71,  15,  27,  74,
   0,  58,   0,   0,  32,   0,  31,   0,  88,  89,
  -2,   0,   0,   0, 160,   0,   0, 131, 132, 134,
 223,   0,  -2, 223,   0,  -2, 142,   0,   0, 217,
 223, 219,   0, 221, 225,   0,   0,   0,   0,  -2,
   0,   0,   0,   0,   0,   0,   0,   0, 170, 207,
  -2,   0,   0,   0, 181, 183, 184, 185,   0,   0,
   0, 179,   0, 196, 172, 247,  68,  70, 251, 252,
 253, 209, 213,   0,   0, 256, 300,   0, 305, 306,
 268,   0,   0,   0,   0,   0,   0, 267, 285, 284,
   0, 286,   0,   0, 280, 281, 282, 288, 285, 317,
 323, 325,   0, 318,  14,  53,  71,  25,  75,  76,
  55,  61,  56,  57,  28,   0,  35,  32,   0,  87,
   0,   0, 159,   0,   0,   0,   0,   0,   0, 133,
 135,   0, 136,   0,   0, 143, 145, 216,   0, 147,
   0,  -2,   0, 177, 151, 227, 218, 220, 224,   0,
   0,   0,  22,  23,   0,  41,  42, 157,  -2,   0,
  -2,   0, 164,   0, 187, 188,   0, 190, 192,   0,
 193,   0,   0,   0, 186,   0,   0,  -2, 175, 165,
 174, 195, 214,   0,   0, 289, 292,   0, 302, 304,
 310, 313, 277, 319,   0,   0, 326,  16,   0,   0,
  35,   0,  36,  37,  40,   0,  30,  79, 122,  95,
   0,   0, 100,   0, 101, 102,   0, 104,  -2,   0,
  84, 161,   0, 162,   0, 122,   0,   0,   0, 129,
 130, 138, 140, 137,   0,   0,   0,   0, 153,   0,
   0,   0,   0,   0,  71,  19,   0,  24,  45, 169,
 201, 203, 166, 200, 204, 167, 168, 202, 205,   0,
 206, 208, 189,   0, 191,   0, 254, 255, 290, 223,
 294,   0, 296, 298,   0, 321, 322, 324,  71,  60,
   0,  34,  38,  32,   0,  81,   0,   0,   0, 177,
 178,   0,   0,   0,   0, 108,   0,   0,   0, 107,
 109, 110, 111,   0,   0,   0,   0, 201, 200,  85,
 120, 121,   0, 144, 146, 178, 154,   0, 156, 150,
 148, 149, 226,   0,  20,  21,   0,   0,  46,  47,
  50,  51,  52,   0, 194, 291, 293, 297, 295,   0,
  17,  33,  39,  29,  80,  91,  93,  94, 123, 125,
   0,  97,   0, 114, 115,  98, 105,  99, 106, 112,
   0, 117,   0, 228, 122, 122,   0,   0,   8,  43,
  44,  48,   0,   0,   0,   0, 126, 128,  96, 113,
 103,   0,   0,  82,  86, 152, 155,  49, 299,  90,
  92, 124,   0, 116, 118, 119, 127 };
#define YYFLAG   -1000
#define YYERROR  goto yyerrlab
#define YYACCEPT return(0)
#define YYABORT  return(1)

/*      parser for yacc output  */

#ifdef YYDEBUG
int yydebug     = 0;     /* 1 for debugging */
#endif
YYSTYPE yyv[YYMAXDEPTH]; /* where the values are stored */
int yychar      = -1;    /* current input token number */
int yynerrs     = 0;     /* number of errors */
short yyerrflag = 0;     /* error recovery flag */

int yyparse() {
    short yys[YYMAXDEPTH];
    short yyj, yym;
    register YYSTYPE *yypvt;
    register short yystate, *yyps, yyn;
    register YYSTYPE *yypv;
    register short *yyxi;

    yystate   = 0;
    yychar    = -1;
    yynerrs   = 0;
    yyerrflag = 0;
    yyps      = &yys[-1];
    yypv      = &yyv[-1];

yystack:    /* put a state and value onto the stack */

#ifdef YYDEBUG
    if (yydebug)
        printf("state %d, char 0%o\n", yystate, yychar);
#endif
    if(++yyps>&yys[YYMAXDEPTH]) {
        yyerror("yacc stack overflow");
        return(1);
    }
    *yyps = yystate;
    ++yypv;
#ifdef UNION
    yyunion(yypv, &yyval);
#else
    *yypv = yyval;
#endif

yynewstate:

    yyn = yypact[yystate];

    if (yyn<=YYFLAG)
        goto yydefault; /* simple state */

    if (yychar<0)
        if ((yychar=yylex())<0)
            yychar=0;
    if ((yyn+=yychar)<0 || yyn>=YYLAST)
        goto yydefault;

    if (yychk[yyn=yyact[yyn]]==yychar) {
        /* valid shift */
        yychar = -1;
#ifdef UNION
        yyunion(&yyval, &yylval);
#else
        yyval = yylval;
#endif
        yystate = yyn;
        if (yyerrflag>0)
            --yyerrflag;
        goto yystack;

    }

yydefault:

    /* default state action */

    if ((yyn=yydef[yystate])== -2) {
        if (yychar<0)
            if ((yychar=yylex())<0)
                yychar = 0;
        /* look through exception table */

        for (yyxi=yyexca; (*yyxi!= (-1)) || (yyxi[1]!=yystate) ; yyxi += 2)
            ; /* VOID */

        for (yyxi+=2; *yyxi >= 0; yyxi+=2) {
            if (*yyxi==yychar)
                break;
        }
        if ((yyn=yyxi[1])<0)
            return(0);   /* accept */
    }

    if (yyn==0) {
        /* error */
        /* error ... attempt to resume parsing */

        switch (yyerrflag) {
            case 0: /* brand new error */
                    yyerror( "syntax error" );

yyerrlab:           ++yynerrs;

            case 1:
            case 2: /* incompletely recovered error ... try again */

                    yyerrflag = 3;

                    /* find a state where "error" is a legal shift action */

                    while (yyps>=yys) {
                        yyn = yypact[*yyps] + YYERRCODE;
                        if (yyn>=0 && yyn<YYLAST
                                   && yychk[yyact[yyn]]==YYERRCODE) {
                            yystate = yyact[yyn];
                            /* simulate a shift of "error" */
                            goto yystack;
                        }
                        yyn = yypact[*yyps];

                        /* the current yyps has no shift on "error",
                           pop stack */

#ifdef YYDEBUG
                        if (yydebug)
                            printf("error recovery pops state %d, uncovers %d\n", *yyps, yyps[-1]);
#endif

                        --yyps;
                        --yypv;
                    }

                    /* there is no state on the stack with an error shift
                       ... abort */

yyabort:            return(1);


            case 3: /* no shift yet; clobber input char */
#ifdef YYDEBUG
                    if (yydebug)
                        printf("error recovery discards char %d\n", yychar);
#endif

                    if (yychar==0)
                        goto yyabort; /* don't discard EOF, quit */
                    yychar = -1;
                    goto yynewstate;   /* try again in the same state */
        }
    }

    /* reduction by production yyn */

#ifdef YYDEBUG
    if (yydebug)
        printf("reduce %d\n",yyn);
#endif
    yyps -= yyr2[yyn];
    yypvt = yypv;
    yypv -= yyr2[yyn];
#ifdef UNION
    yyunion(&yyval, &yypv[1]);
#else
    yyval = yypv[1];
#endif
    yym=yyn;
    /* consult goto table to find next state */
    yyn = yyr1[yyn];
    yyj = yypgo[yyn] + *yyps + 1;
    if (yyj>=YYLAST || yychk[yystate=yyact[yyj]]!= -yyn)
        yystate = yyact[yypgo[yyn]];
    switch(yym) {
        
case 1:
# line 85
{inputExpr = letrec(yypvt[-0],yypvt[-1]); sp-=2;} break;
case 2:
# line 86
{valDefns  = yypvt[-0];            sp-=1;} break;
case 3:
# line 87
{syntaxError("input");} break;
case 4:
# line 96
{yyval = gc2(yypvt[-1]);} break;
case 5:
# line 97
{yyval = yypvt[-0];} break;
case 6:
# line 99
{yyval = gc2(appendOnto(yypvt[-0],yypvt[-1]));} break;
case 7:
# line 100
{yyval = yypvt[-0];} break;
case 8:
# line 103
{yyval = gc7(yypvt[-1]);} break;
case 9:
# line 104
{syntaxError("module definition");} break;
case 10:
# line 106
{yyval = yypvt[-0];} break;
case 11:
# line 107
{yyval = yypvt[-0];} break;
case 12:
# line 108
{yyval = yypvt[-0];} break;
case 13:
# line 110
{yyval = yypvt[-0];} break;
case 14:
# line 111
{yyval = gc3(yypvt[-0]);} break;
case 15:
# line 112
{yyval = gc2(NIL);} break;
case 16:
# line 113
{yyval = gc4(yypvt[-0]);} break;
case 17:
# line 115
{yyval = gc6(yypvt[-0]);} break;
case 18:
# line 120
{yyval = gc0(NIL);} break;
case 19:
# line 121
{yyval = gc3(NIL);} break;
case 20:
# line 122
{yyval = gc4(NIL);} break;
case 21:
# line 124
{yyval = gc3(NIL);} break;
case 22:
# line 125
{yyval = yypvt[-0];} break;
case 23:
# line 127
{yyval = yypvt[-0];} break;
case 24:
# line 128
{yyval = gc2(NIL);} break;
case 25:
# line 133
{imps = cons(yypvt[-0],imps); yyval=gc3(NIL);} break;
case 26:
# line 134
{imps = singleton(yypvt[-0]); yyval=gc1(NIL);} break;
case 27:
# line 136
{if (chase(imps)) {
					     clearStack();
					     onto(imps);
                                             done();
					     closeAnyInput();
					     return 0;
					 }
					 yyval = gc0(NIL);
					} break;
case 28:
# line 146
{yyval = gc3(yypvt[-1]);} break;
case 29:
# line 148
{yyval = gc6(yypvt[-3]);} break;
case 30:
# line 150
{yyval = gc4(yypvt[-1]);} break;
case 31:
# line 151
{syntaxError("import declaration");} break;
case 32:
# line 153
{yyval = gc0(NIL);} break;
case 33:
# line 154
{yyval = gc4(NIL);} break;
case 34:
# line 155
{yyval = gc3(NIL);} break;
case 35:
# line 157
{yyval = gc0(NIL);} break;
case 36:
# line 158
{yyval = gc1(NIL);} break;
case 37:
# line 159
{yyval = yypvt[-0];} break;
case 38:
# line 160
{yyval = gc2(yypvt[-1]);} break;
case 39:
# line 162
{yyval = gc3(NIL);} break;
case 40:
# line 163
{yyval = yypvt[-0];} break;
case 41:
# line 165
{yyval = yypvt[-0];} break;
case 42:
# line 166
{yyval = yypvt[-0];} break;
case 43:
# line 167
{yyval = gc4(NIL);} break;
case 44:
# line 168
{yyval = gc4(NIL);} break;
case 45:
# line 170
{yyval = gc0(NIL);} break;
case 46:
# line 171
{yyval = gc1(NIL);} break;
case 47:
# line 172
{yyval = yypvt[-0];} break;
case 48:
# line 173
{yyval = gc2(yypvt[-1]);} break;
case 49:
# line 175
{yyval = gc3(NIL);} break;
case 50:
# line 176
{yyval = gc1(NIL);} break;
case 51:
# line 178
{yyval = yypvt[-0];} break;
case 52:
# line 179
{yyval = yypvt[-0];} break;
case 53:
# line 184
{yyval = gc2(NIL);} break;
case 54:
# line 185
{yyval = gc0(NIL);} break;
case 55:
# line 187
{fixDefn(LEFT_ASS,yypvt[-2],yypvt[-1],yypvt[-0]); sp-=3;} break;
case 56:
# line 188
{fixDefn(RIGHT_ASS,yypvt[-2],yypvt[-1],yypvt[-0]);sp-=3;} break;
case 57:
# line 189
{fixDefn(NON_ASS,yypvt[-2],yypvt[-1],yypvt[-0]);  sp-=3;} break;
case 58:
# line 191
{yyval = gc1(checkPrec(yypvt[-0]));} break;
case 59:
# line 192
{yyval = gc0(mkInt(DEF_PREC));} break;
case 60:
# line 194
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 61:
# line 195
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 62:
# line 197
{yyval = yypvt[-0];} break;
case 63:
# line 198
{yyval = yypvt[-0];} break;
case 64:
# line 199
{yyval = gc1(varMinus);} break;
case 65:
# line 201
{yyval = yypvt[-0];} break;
case 66:
# line 202
{yyval = gc1(varBang);} break;
case 67:
# line 203
{yyval = gc1(varDot);} break;
case 68:
# line 204
{yyval = gc3(yypvt[-1]);} break;
case 69:
# line 206
{yyval = yypvt[-0];} break;
case 70:
# line 207
{yyval = gc3(yypvt[-1]);} break;
case 71:
# line 212
{yyval = gc0(NIL);} break;
case 72:
# line 213
{yyval = gc1(NIL);} break;
case 73:
# line 214
{yyval = yypvt[-0];} break;
case 74:
# line 215
{yyval = gc2(yypvt[-1]);} break;
case 75:
# line 217
{yyval = gc2(yypvt[-2]);} break;
case 76:
# line 218
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 77:
# line 219
{yyval = gc0(NIL);} break;
case 78:
# line 220
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 79:
# line 225
{defTycon(4,yypvt[-1],yypvt[-2],yypvt[-0],SYNONYM);} break;
case 80:
# line 227
{defTycon(6,yypvt[-3],yypvt[-4],
						    ap(yypvt[-2],yypvt[-0]),RESTRICTSYN);} break;
case 81:
# line 230
{defTycon(5,yypvt[-2],checkTyLhs(yypvt[-3]),
						    ap(rev(yypvt[-1]),yypvt[-0]),DATATYPE);} break;
case 82:
# line 233
{defTycon(7,yypvt[-2],yypvt[-3],
						  ap(ap(QUAL,pair(yypvt[-5],rev(yypvt[-1]))),
						     yypvt[-0]),DATATYPE);} break;
case 83:
# line 236
{defTycon(2,yypvt[-1],checkTyLhs(yypvt[-0]),
						    ap(NIL,NIL),DATATYPE);} break;
case 84:
# line 238
{defTycon(4,yypvt[-3],yypvt[-0],
						  ap(ap(QUAL,pair(yypvt[-2],NIL)),
						     NIL),DATATYPE);} break;
case 85:
# line 242
{defTycon(5,yypvt[-2],checkTyLhs(yypvt[-3]),
						    ap(yypvt[-1],yypvt[-0]),NEWTYPE);} break;
case 86:
# line 245
{defTycon(7,yypvt[-2],yypvt[-3],
						  ap(ap(QUAL,pair(yypvt[-5],yypvt[-1])),
						     yypvt[-0]),NEWTYPE);} break;
case 87:
# line 249
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 88:
# line 250
{yyval = yypvt[-0];} break;
case 89:
# line 251
{syntaxError("type defn lhs");} break;
case 90:
# line 253
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 91:
# line 254
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 92:
# line 256
{yyval = gc3(sigdecl(yypvt[-1],singleton(yypvt[-2]),
							     yypvt[-0]));} break;
case 93:
# line 258
{yyval = yypvt[-0];} break;
case 94:
# line 260
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 95:
# line 261
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 96:
# line 263
{yyval = gc4(ap(ap(yypvt[-1],bang(yypvt[-2])),yypvt[-0]));} break;
case 97:
# line 264
{yyval = gc3(ap(ap(yypvt[-1],yypvt[-2]),yypvt[-0]));} break;
case 98:
# line 265
{yyval = gc3(ap(ap(yypvt[-1],yypvt[-2]),yypvt[-0]));} break;
case 99:
# line 266
{yyval = gc3(ap(ap(yypvt[-1],yypvt[-2]),yypvt[-0]));} break;
case 100:
# line 267
{yyval = yypvt[-0];} break;
case 101:
# line 268
{yyval = yypvt[-0];} break;
case 102:
# line 269
{yyval = yypvt[-0];} break;
case 103:
# line 270
{yyval = gc4(ap(LABC,pair(yypvt[-3],rev(yypvt[-1]))));} break;
case 104:
# line 271
{syntaxError("data type definition");} break;
case 105:
# line 273
{yyval = gc3(ap(yypvt[-2],bang(yypvt[-0])));} break;
case 106:
# line 274
{yyval = gc3(ap(yypvt[-2],bang(yypvt[-0])));} break;
case 107:
# line 275
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 108:
# line 277
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 109:
# line 278
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 110:
# line 279
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 111:
# line 280
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 112:
# line 281
{yyval = gc3(ap(yypvt[-2],bang(yypvt[-0])));} break;
case 113:
# line 283
{yyval = gc2(bang(yypvt[-0]));} break;
case 114:
# line 284
{yyval = yypvt[-0];} break;
case 115:
# line 285
{yyval = yypvt[-0];} break;
case 116:
# line 287
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 117:
# line 288
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 118:
# line 290
{yyval = gc3(pair(rev(yypvt[-2]),yypvt[-0]));} break;
case 119:
# line 291
{yyval = gc3(pair(rev(yypvt[-2]),yypvt[-0]));} break;
case 120:
# line 293
{yyval = gc2(singleton(ap(yypvt[-1],yypvt[-0])));} break;
case 121:
# line 294
{yyval = gc2(singleton(ap(yypvt[-1],yypvt[-0])));} break;
case 122:
# line 296
{yyval = gc0(NIL);} break;
case 123:
# line 297
{yyval = gc2(singleton(yypvt[-0]));} break;
case 124:
# line 298
{yyval = gc4(yypvt[-1]);} break;
case 125:
# line 300
{yyval = gc0(NIL);} break;
case 126:
# line 301
{yyval = gc1(rev(yypvt[-0]));} break;
case 127:
# line 303
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 128:
# line 304
{yyval = gc1(singleton(yypvt[-0]));} break;
case 129:
# line 309
{primDefn(yypvt[-3],yypvt[-2],yypvt[-0]); sp-=4;} break;
case 130:
# line 311
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 131:
# line 312
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 132:
# line 313
{syntaxError("primitive defn");} break;
case 133:
# line 315
{yyval = gc2(pair(yypvt[-1],yypvt[-0]));} break;
case 134:
# line 316
{yyval = yypvt[-0];} break;
case 135:
# line 321
{classDefn(intOf(yypvt[-2]),yypvt[-1],yypvt[-0]); sp-=3;} break;
case 136:
# line 322
{instDefn(intOf(yypvt[-2]),yypvt[-1],yypvt[-0]);  sp-=3;} break;
case 137:
# line 323
{defaultDefn(intOf(yypvt[-3]),yypvt[-1]);  sp-=4;} break;
case 138:
# line 325
{yyval = gc3(pair(yypvt[-2],checkPred(yypvt[-0])));} break;
case 139:
# line 326
{yyval = gc1(pair(NIL,checkPred(yypvt[-0])));} break;
case 140:
# line 328
{yyval = gc3(pair(yypvt[-2],checkPred(yypvt[-0])));} break;
case 141:
# line 329
{yyval = gc1(pair(NIL,checkPred(yypvt[-0])));} break;
case 142:
# line 331
{yyval = gc0(NIL);} break;
case 143:
# line 332
{yyval = gc1(rev(yypvt[-0]));} break;
case 144:
# line 334
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 145:
# line 335
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 146:
# line 340
{yyval = gc3(ap(QUAL,pair(yypvt[-2],yypvt[-0])));} break;
case 147:
# line 341
{yyval = yypvt[-0];} break;
case 148:
# line 343
{yyval = gc3(ap(ap(typeArrow,yypvt[-2]),yypvt[-0]));} break;
case 149:
# line 344
{yyval = gc3(ap(ap(typeArrow,yypvt[-2]),yypvt[-0]));} break;
case 150:
# line 345
{yyval = gc3(ap(ap(typeArrow,yypvt[-2]),yypvt[-0]));} break;
case 151:
# line 346
{yyval = yypvt[-0];} break;
case 152:
# line 348
{yyval = gc4(ap(POLYTYPE,
						     pair(rev(yypvt[-2]),yypvt[-0])));} break;
case 153:
# line 350
{yyval = yypvt[-0];} break;
case 154:
# line 352
{yyval = gc3(yypvt[-1]);} break;
case 155:
# line 354
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 156:
# line 355
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 157:
# line 357
{yyval = gc3(ap(QUAL,pair(yypvt[-2],yypvt[-0])));} break;
case 158:
# line 358
{yyval = yypvt[-0];} break;
case 159:
# line 360
{yyval = gc2(NIL);} break;
case 160:
# line 361
{yyval = gc1(singleton(checkPred(yypvt[-0])));} break;
case 161:
# line 362
{yyval = gc3(singleton(checkPred(yypvt[-1])));} break;
case 162:
# line 363
{yyval = gc3(checkContext(yypvt[-1]));} break;
case 163:
# line 365
{yyval = gc1(singleton(yypvt[-0]));} break;
case 164:
# line 366
{yyval = gc3(checkContext(yypvt[-1]));} break;
case 165:
# line 368
{yyval = gc3(ap(mkExt(textOf(yypvt[-0])),yypvt[-2]));} break;
case 166:
# line 370
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 167:
# line 371
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 168:
# line 372
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 169:
# line 373
{yyval = gc3(cons(yypvt[-0],cons(yypvt[-2],NIL)));} break;
case 170:
# line 374
{yyval = gc1(singleton(yypvt[-0]));} break;
case 171:
# line 377
{yyval = yypvt[-0];} break;
case 172:
# line 378
{yyval = yypvt[-0];} break;
case 173:
# line 380
{yyval = yypvt[-0];} break;
case 174:
# line 381
{yyval = gc3(ap(ap(typeArrow,yypvt[-2]),yypvt[-0]));} break;
case 175:
# line 382
{yyval = gc3(ap(ap(typeArrow,yypvt[-2]),yypvt[-0]));} break;
case 176:
# line 383
{syntaxError("type expression");} break;
case 177:
# line 385
{yyval = yypvt[-0];} break;
case 178:
# line 386
{yyval = yypvt[-0];} break;
case 179:
# line 388
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 180:
# line 389
{yyval = yypvt[-0];} break;
case 181:
# line 391
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 182:
# line 392
{yyval = yypvt[-0];} break;
case 183:
# line 394
{yyval = yypvt[-0];} break;
case 184:
# line 395
{yyval = yypvt[-0];} break;
case 185:
# line 397
{yyval = yypvt[-0];} break;
case 186:
# line 398
{yyval = gc2(typeUnit);} break;
case 187:
# line 399
{yyval = gc3(typeArrow);} break;
case 188:
# line 400
{yyval = gc3(yypvt[-1]);} break;
case 189:
# line 401
{yyval = gc3(yypvt[-1]);} break;
case 190:
# line 402
{yyval = gc3(yypvt[-1]);} break;
case 191:
# line 403
{yyval = gc3(buildTuple(yypvt[-1]));} break;
case 192:
# line 404
{yyval = gc3(buildTuple(yypvt[-1]));} break;
case 193:
# line 406
{yyval = gc3(revOnto(yypvt[-1],typeNoRow));} break;
case 194:
# line 407
{yyval = gc5(revOnto(yypvt[-3],yypvt[-1]));} break;
case 195:
# line 409
{yyval = gc3(ap(typeList,yypvt[-1]));} break;
case 196:
# line 410
{yyval = gc2(typeList);} break;
case 197:
# line 411
{yyval = gc1(inventVar());} break;
case 198:
# line 413
{yyval = gc2(mkTuple(tupleOf(yypvt[-1])+1));} break;
case 199:
# line 414
{yyval = gc1(mkTuple(2));} break;
case 200:
# line 416
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 201:
# line 417
{yyval = gc3(cons(yypvt[-0],cons(yypvt[-2],NIL)));} break;
case 202:
# line 419
{yyval = gc3(cons(yypvt[-0],cons(yypvt[-2],NIL)));} break;
case 203:
# line 420
{yyval = gc3(cons(yypvt[-0],cons(yypvt[-2],NIL)));} break;
case 204:
# line 421
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 205:
# line 422
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 206:
# line 425
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 207:
# line 426
{yyval = gc1(singleton(yypvt[-0]));} break;
case 208:
# line 428
{yyval = gc3(ap(mkExt(textOf(yypvt[-2])),yypvt[-0]));} break;
case 209:
# line 434
{yyval = gc3(yypvt[-1]);} break;
case 210:
# line 436
{yyval = gc0(NIL);} break;
case 211:
# line 437
{yyval = gc1(NIL);} break;
case 212:
# line 438
{yyval = yypvt[-0];} break;
case 213:
# line 439
{yyval = gc2(yypvt[-1]);} break;
case 214:
# line 441
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 215:
# line 442
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 216:
# line 444
{yyval = gc3(sigdecl(yypvt[-1],yypvt[-2],yypvt[-0]));} break;
case 217:
# line 445
{yyval = gc2(pair(yypvt[-1],yypvt[-0]));} break;
case 218:
# line 447
{yyval = gc2(letrec(yypvt[-0],yypvt[-1]));} break;
case 219:
# line 448
{syntaxError("declaration");} break;
case 220:
# line 450
{yyval = gc2(pair(yypvt[-1],yypvt[-0]));} break;
case 221:
# line 451
{yyval = gc1(grded(rev(yypvt[-0])));} break;
case 222:
# line 453
{yyval = gc2(yypvt[-0]);} break;
case 223:
# line 454
{yyval = gc0(NIL);} break;
case 224:
# line 456
{yyval = gc2(cons(yypvt[-0],yypvt[-1]));} break;
case 225:
# line 457
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 226:
# line 459
{yyval = gc4(pair(yypvt[-1],pair(yypvt[-2],yypvt[-0])));} break;
case 227:
# line 461
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 228:
# line 462
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 229:
# line 464
{yyval = yypvt[-0];} break;
case 230:
# line 465
{yyval = gc3(varMinus);} break;
case 231:
# line 467
{yyval = yypvt[-0];} break;
case 232:
# line 468
{yyval = gc3(yypvt[-1]);} break;
case 233:
# line 469
{yyval = gc3(varBang);} break;
case 234:
# line 470
{yyval = gc3(varDot);} break;
case 235:
# line 472
{yyval = yypvt[-0];} break;
case 236:
# line 473
{yyval = gc1(varHiding);} break;
case 237:
# line 474
{yyval = gc1(varQualified);} break;
case 238:
# line 475
{yyval = gc1(varAsMod);} break;
case 239:
# line 477
{yyval = yypvt[-0];} break;
case 240:
# line 478
{yyval = gc3(yypvt[-1]);} break;
case 241:
# line 483
{yyval = yypvt[-0];} break;
case 242:
# line 484
{syntaxError("expression");} break;
case 243:
# line 486
{yyval = gc3(ap(ESIGN,pair(yypvt[-2],yypvt[-0])));} break;
case 244:
# line 487
{yyval = yypvt[-0];} break;
case 245:
# line 489
{yyval = gc1(tidyInfix(yypvt[-0]));} break;
case 246:
# line 490
{yyval = yypvt[-0];} break;
case 247:
# line 492
{yyval = gc4(ap(NEG,ap(ap(yypvt[-2],yypvt[-3]),yypvt[-0])));} break;
case 248:
# line 493
{yyval = gc3(ap(ap(yypvt[-1],yypvt[-2]),yypvt[-0]));} break;
case 249:
# line 494
{yyval = gc2(ap(NEG,only(yypvt[-0])));} break;
case 250:
# line 495
{yyval = gc3(ap(ap(yypvt[-1],only(yypvt[-2])),yypvt[-0]));} break;
case 251:
# line 496
{yyval = gc4(ap(NEG,
						     ap(ap(yypvt[-2],only(yypvt[-3])),yypvt[-0])));} break;
case 252:
# line 499
{yyval = gc4(ap(LAMBDA,
						     pair(rev(yypvt[-2]),
							  pair(yypvt[-1],yypvt[-0]))));} break;
case 253:
# line 502
{yyval = gc4(letrec(yypvt[-2],yypvt[-0]));} break;
case 254:
# line 503
{yyval = gc6(ap(COND,triple(yypvt[-4],yypvt[-2],yypvt[-0])));} break;
case 255:
# line 504
{yyval = gc6(ap(CASE,pair(yypvt[-4],rev(yypvt[-1]))));} break;
case 256:
# line 505
{yyval = gc4(ap(DOCOMP,checkDo(yypvt[-1])));} break;
case 257:
# line 506
{yyval = yypvt[-0];} break;
case 258:
# line 508
{yyval = gc2(cons(yypvt[-0],yypvt[-1]));} break;
case 259:
# line 509
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 260:
# line 511
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 261:
# line 512
{yyval = yypvt[-0];} break;
case 262:
# line 514
{yyval = yypvt[-0];} break;
case 263:
# line 515
{yyval = gc3(ap(ASPAT,pair(yypvt[-2],yypvt[-0])));} break;
case 264:
# line 516
{yyval = gc2(ap(LAZYPAT,yypvt[-0]));} break;
case 265:
# line 517
{yyval = gc1(WILDCARD);} break;
case 266:
# line 518
{yyval = yypvt[-0];} break;
case 267:
# line 519
{yyval = gc4(ap(CONFLDS,pair(yypvt[-3],yypvt[-1])));} break;
case 268:
# line 520
{yyval = gc4(ap(UPDFLDS,
						     triple(yypvt[-3],NIL,yypvt[-1])));} break;
case 269:
# line 522
{yyval = gc2(nameUnit);} break;
case 270:
# line 523
{yyval = yypvt[-0];} break;
case 271:
# line 524
{yyval = yypvt[-0];} break;
case 272:
# line 525
{yyval = yypvt[-0];} break;
case 273:
# line 526
{yyval = yypvt[-0];} break;
case 274:
# line 527
{yyval = gc3(yypvt[-1]);} break;
case 275:
# line 528
{yyval = gc3(buildTuple(yypvt[-1]));} break;
case 276:
# line 530
{yyval = gc3(revOnto(yypvt[-1],nameNoRec));} break;
case 277:
# line 531
{yyval = gc5(revOnto(yypvt[-3],yypvt[-1]));} break;
case 278:
# line 532
{yyval = yypvt[-0];} break;
case 279:
# line 534
{yyval = gc3(yypvt[-1]);} break;
case 280:
# line 535
{yyval = gc4(ap(yypvt[-1],yypvt[-2]));} break;
case 281:
# line 536
{yyval = gc4(ap(ap(nameFlip,yypvt[-2]),yypvt[-1]));} break;
case 282:
# line 537
{yyval = gc4(ap(ap(nameFlip,yypvt[-2]),yypvt[-1]));} break;
case 283:
# line 538
{yyval = gc3(yypvt[-1]);} break;
case 284:
# line 540
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 285:
# line 541
{yyval = gc3(cons(yypvt[-0],cons(yypvt[-2],NIL)));} break;
case 286:
# line 544
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 287:
# line 545
{yyval = gc1(singleton(yypvt[-0]));} break;
case 288:
# line 547
{yyval = gc3(ap(mkExt(textOf(yypvt[-2])),yypvt[-0]));} break;
case 289:
# line 550
{yyval = yypvt[-0];} break;
case 290:
# line 551
{yyval = gc2(yypvt[-1]);} break;
case 291:
# line 553
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 292:
# line 554
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 293:
# line 556
{yyval = gc3(pair(yypvt[-2],letrec(yypvt[-0],yypvt[-1])));} break;
case 294:
# line 558
{yyval = gc1(grded(rev(yypvt[-0])));} break;
case 295:
# line 559
{yyval = gc2(pair(yypvt[-1],yypvt[-0]));} break;
case 296:
# line 560
{syntaxError("case expression");} break;
case 297:
# line 562
{yyval = gc2(cons(yypvt[-0],yypvt[-1]));} break;
case 298:
# line 563
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 299:
# line 565
{yyval = gc4(pair(yypvt[-1],pair(yypvt[-2],yypvt[-0])));} break;
case 300:
# line 567
{yyval = gc2(yypvt[-1]);} break;
case 301:
# line 568
{yyval = yypvt[-0];} break;
case 302:
# line 570
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 303:
# line 571
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 304:
# line 573
{yyval = gc3(ap(FROMQUAL,pair(yypvt[-2],yypvt[-0])));} break;
case 305:
# line 574
{yyval = gc2(ap(QWHERE,yypvt[-0]));} break;
case 306:
# line 575
{yyval = gc2(ap(BOOLQUAL,yypvt[-0]));} break;
case 307:
# line 576
{yyval = gc1(ap(DOQUAL,yypvt[-0]));} break;
case 308:
# line 578
{yyval = gc0(NIL);} break;
case 309:
# line 579
{yyval = gc1(rev(yypvt[-0]));} break;
case 310:
# line 581
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 311:
# line 582
{yyval = gc1(singleton(yypvt[-0]));} break;
case 312:
# line 584
{yyval = yypvt[-0];} break;
case 313:
# line 585
{yyval = gc3(pair(yypvt[-2],yypvt[-0]));} break;
case 314:
# line 590
{yyval = gc0(nameNil);} break;
case 315:
# line 591
{yyval = gc1(ap(FINLIST,cons(yypvt[-0],NIL)));} break;
case 316:
# line 592
{yyval = gc1(ap(FINLIST,rev(yypvt[-0])));} break;
case 317:
# line 593
{yyval = gc3(ap(COMP,pair(yypvt[-2],rev(yypvt[-0]))));} break;
case 318:
# line 594
{yyval = gc3(ap(ap(nameFromTo,yypvt[-2]),yypvt[-0]));} break;
case 319:
# line 595
{yyval = gc4(ap(ap(nameFromThen,yypvt[-3]),yypvt[-1]));} break;
case 320:
# line 596
{yyval = gc2(ap(nameFrom,yypvt[-1]));} break;
case 321:
# line 597
{yyval = gc5(ap(ap(ap(nameFromThenTo,
							       yypvt[-4]),yypvt[-2]),yypvt[-0]));} break;
case 322:
# line 600
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 323:
# line 601
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 324:
# line 603
{yyval = gc3(ap(FROMQUAL,pair(yypvt[-2],yypvt[-0])));} break;
case 325:
# line 604
{yyval = gc1(ap(BOOLQUAL,yypvt[-0]));} break;
case 326:
# line 605
{yyval = gc2(ap(QWHERE,yypvt[-0]));} break;
case 327:
# line 610
{yyerrok; goOffside(startColumn);} break;
case 328:
# line 613
{yyval = yypvt[-0];} break;
case 329:
# line 614
{yyerrok;
					 if (canUnOffside()) {
					     unOffside();
					     /* insert extra token on stack*/
					     push(NIL);
					     pushed(0) = pushed(1);
					     pushed(1) = mkInt(column);
					 }
					 else
					     syntaxError("definition");
					} break;/* End of actions */
    }
    goto yystack;  /* stack new state and value */

}
